#----------------------------------------------------------------------
sub eventGraphPerf
#----------------------------------------------------------------------
{
  my $eg_thishost = $_[0]; 
  my $eg_metric   = $_[1]; 

  my %rowcache = (); 
  my $this_ts  = ""; 

  my $eg_days  = 10; 
  my $eg_debug = 0; 

  &logit("DEBUG - eventGraphPerf - Starting - eg_thishost=$eg_thishost eg_metric=$eg_metric eg_title=$eg_title") if $eg_debug;

  ##my $sql = "SELECT     zdate_char, 
  ##           ORDER BY 1 ";
  my $sql = "SELECT     dbamon.dbamon.dateconvert_19(ts), 
                        value 
              FROM      dbamon.dbamon.metrics_detail
              WHERE     dbamonmode = '$mode'
                        AND category = 'PERF_$eg_metric' 
                        and instance = '$titleraw[$eg_thishost]'
                        and ts > dateadd(dd, -$eg_days, getdate())";

  &msg("DEBUG - Running sql=$sql") if $eg_debug; 

  $sth = $dbh->prepare($sql) || &error('sql_659');
  $sth->execute || &error('sql_660');

  open(DOUT, ">$tmpfl4") || &error("Cannot open output tmpfl4=$tmpfl4 - $!");

  my $rows = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $val = $Data[1];

    #---- Edit ts to the format that ploticus likes
    $ts = substr($ts,0,16); 
    $ts =~ s/\-/\./; 

    $rowcache{$ts} = $val;
  }

  foreach $this_ts ( sort keys %rowcache )
  {
    print DOUT "$this_ts $rowcache{$this_ts}\n";
    $rows++;
  }

  close(DOUT);
  &msg("Wrote $rows records to $tmpfl4") if $eg_debug;
  $moving_avg = int($rows / 5); 

  if ($eg_debug)
  {
    &msg("Last 10 lines of tmpfl4:");
    system("tail -10 $tmpfl4");
  }

  chdir("/opt/dbamon/ploticus");

  $ENV{'DBAMON_PL_FILE'}           = $tmpfl4;
  $ENV{'DBAMON_PL_TITLE1'}         = "Instance: $titleraw[$eg_thishost]" ;
  $ENV{'DBAMON_PL_TITLE2'}         = "Perf. Metric: PERF_$eg_metric - All Obs. From The Last $eg_days Days";
  $ENV{'DBAMON_PL_MOVINGAVGCOUNT'} = $moving_avg;
  $ENV{'DBAMON_PL_LASTVAL'}        = $val;

  ##$cmd = "dbamon_pl_run SingleLineUserTitles"; #---- 5.52B - Old
  ##$cmd = "dbamon_pl_run SingleLine";  # TEST
  $cmd = "dbamon_pl_run";   #---- 5.52B - Don't have to specify PL program any more

  &msg("Invoking Ploticus - cmd=($cmd)") if $eg_debug;
  $rc = system("$cmd > $tmpfl5 2>&1");
  &msg("Back from dbamon_pl_run - rc=$rc") if $eg_debug;
  &error("Ploticus failed - rc=$rc") if $rc != 0;

  system("cat $tmpfl5") if $eg_debug;

  #---- Find PNG_File: name
  open(CMDOUT, "$tmpfl5") || &error("Cannot open input - tmpfl5=$tmpfl5 - $!");
  while(<CMDOUT>)
  {
    if (/^PNG_File:/)
    {
      @words = split;
      $png_file = $words[1];
    }
  }

  $png_file_long = "/opt/dbamon/htm/graphs/dyn/$png_file" if $png_file;
  &msg("Returning PNG file - png_file=$png_file - png_file_long=$png_file_long") if $eg_debug;
 
  if (-e "$png_file_long") 
  {
    return $png_file; 
  }
  else
  {
    return;
  }
}

#----------------------------------------------------------------------
1;
